/*******************************************************************************
 * @file    config.h
 * @author  King
 * @version V1.00
 * @date    27-Nov-2021
 * @brief   ......
*******************************************************************************/


/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __CONFIG_H__
#define __CONFIG_H__


/* Exported constants --------------------------------------------------------*/
#define ADC_ENABLE      0
#define CAN_ENABLE      0
#define DAC_ENABLE      0
#define KEY_ENABLE      0
#define LCD_ENABLE      1
#define LED_ENABLE      1
#define OLED1_ENABLE    0
#define OLED2_ENABLE    0
#define PWM_ENABLE      0
#define RTC_ENABLE      0


/* Includes ------------------------------------------------------------------*/
#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>


/* Includes ------------------------------------------------------------------*/
#include "mf_config.h"


#if defined(USE_FULL_ASSERT)
#include "fm33_assert.h"
#endif


/* Includes ------------------------------------------------------------------*/
#include "ADC.h"
#include "CAN.h"
#include "DAC.h"
#include "KEY.h"
#include "LCD.h"
#include "LED.h"
#include "LPTIMxx.h"
#include "LPUARTx.h"
#include "MCU.h"
#include "OLED1.h"
#include "OLED2.h"
#include "RTC.h"


/* Includes ------------------------------------------------------------------*/
#include "TASK.h"


#endif


/******************* (C) COPYRIGHT 2021 *************************END OF FILE***/

