/*******************************************************************************
 * @file    main.c
 * @author  King
 * @version V1.00
 * @date    27-Nov-2021
 * @brief   ......
*******************************************************************************/


/* Define to prevent recursive inclusion -------------------------------------*/
#define __MAIN_C__


/* Includes ------------------------------------------------------------------*/
#include "main.h"


/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/


/* Exported variables --------------------------------------------------------*/
/* Exported function prototypes ----------------------------------------------*/


/*******************************************************************************
 * @brief       
 * @param       
 * @retval      
 * @attention   
*******************************************************************************/
int main(void)
{
    MCU_Init();

#if ADC_ENABLE
    ADC_Configure();
#endif

#if CAN_ENABLE
    CAN_Configure();
#endif


#if DAC_ENABLE
    DAC_Configure();
#endif

#if RTC_ENABLE
    RTC_Configure();
#endif

#if PWM_ENABLE
    LPTIM16_Init();
#endif

#if KEY_ENABLE
    KEY_Init();
#endif

#if LCD_ENABLE
    LCD_Init();
#endif

#if LED_ENABLE
    LED_Init();
#endif

#if OLED1_ENABLE
    OLED1_Init();
#endif

#if OLED2_ENABLE
    OLED2_Init();
#endif

    printf("\r\nDEMO V1.1 FM33LG0xx %s %s\r\n", __DATE__, __TIME__);

    while(1)
    {
        TASK_Scheduling();
    }
}


/******************* (C) COPYRIGHT 2021 *************************END OF FILE***/

