/*******************************************************************************
 * @file    KEY.h
 * @author  King
 * @version V1.00
 * @date    27-Nov-2021
 * @brief   ......
*******************************************************************************/


/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __KEY_H__
#define __KEY_H__


#ifdef __cplusplus
extern "C" {
#endif


#undef  EXTERN


#ifdef  __KEY_C__
#define EXTERN
#else
#define EXTERN extern
#endif


/* Includes ------------------------------------------------------------------*/
#include "config.h"


#if KEY_ENABLE


/* Exported constants --------------------------------------------------------*/
#define KEY_NUMBER  4

#define KEY1_GPIO   GPIOD
#define KEY1_PIN    FL_GPIO_PIN_9   /* WKUP8 */

#define KEY2_GPIO   GPIOE
#define KEY2_PIN    FL_GPIO_PIN_6   /* WKUP9 */

#define KEY3_GPIO   GPIOE
#define KEY3_PIN    FL_GPIO_PIN_7

#define KEY4_GPIO   GPIOC
#define KEY4_PIN    FL_GPIO_PIN_6   /* WKUP4 */


/* Exported types ------------------------------------------------------------*/
typedef struct
{
    GPIO_Type *GPIOx;
    uint32_t   pin;
} KEY_TypeDef;


/* Exported macro ------------------------------------------------------------*/


/* Exported functions --------------------------------------------------------*/
EXTERN void KEY_Init(void);
EXTERN void KEY_Scan(void);


#endif


#ifdef __cplusplus
}
#endif


#endif


/******************* (C) COPYRIGHT 2021 *************************END OF FILE***/

