/*******************************************************************************
 * @file    LPUARTx.c
 * @author  King
 * @version V1.00
 * @date    27-Nov-2021
 * @brief   ......
*******************************************************************************/


/* Define to prevent recursive inclusion -------------------------------------*/
#define __LPUARTx_C__


/* Includes ------------------------------------------------------------------*/
#include "LPUARTx.h"
#include "nr_micro_shell.h"


/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/


/* Exported variables --------------------------------------------------------*/
/* Exported function prototypes ----------------------------------------------*/


/*******************************************************************************
 * @brief       
 * @param       
 * @retval      
 * @attention   
*******************************************************************************/
void LPUARTx_Init(LPUART_Type *LPUARTx)
{
    FL_GPIO_InitTypeDef   GPIO_InitStruct;
    FL_LPUART_InitTypeDef LPUART_InitStruct;

    if(LPUARTx == LPUART0)
    {
        FL_GPIO_StructInit(&GPIO_InitStruct);
        GPIO_InitStruct.pin        = FL_GPIO_PIN_13;
        GPIO_InitStruct.mode       = FL_GPIO_MODE_DIGITAL;
        GPIO_InitStruct.outputType = FL_GPIO_OUTPUT_PUSHPULL;
        GPIO_InitStruct.pull       = FL_ENABLE;
        GPIO_InitStruct.remapPin   = FL_ENABLE;
        FL_GPIO_Init(GPIOA, &GPIO_InitStruct);

        FL_GPIO_StructInit(&GPIO_InitStruct);
        GPIO_InitStruct.pin        = FL_GPIO_PIN_14;
        GPIO_InitStruct.mode       = FL_GPIO_MODE_DIGITAL;
        GPIO_InitStruct.outputType = FL_GPIO_OUTPUT_PUSHPULL;
        GPIO_InitStruct.pull       = FL_DISABLE;
        GPIO_InitStruct.remapPin   = FL_ENABLE;
        FL_GPIO_Init(GPIOA, &GPIO_InitStruct);
    }

    if(LPUARTx == LPUART1)
    {
        FL_GPIO_StructInit(&GPIO_InitStruct);
        GPIO_InitStruct.pin        = FL_GPIO_PIN_2;
        GPIO_InitStruct.mode       = FL_GPIO_MODE_DIGITAL;
        GPIO_InitStruct.outputType = FL_GPIO_OUTPUT_PUSHPULL;
        GPIO_InitStruct.pull       = FL_ENABLE;
        GPIO_InitStruct.remapPin   = FL_ENABLE;
        FL_GPIO_Init(GPIOC, &GPIO_InitStruct);

        FL_GPIO_StructInit(&GPIO_InitStruct);
        GPIO_InitStruct.pin        = FL_GPIO_PIN_3;
        GPIO_InitStruct.mode       = FL_GPIO_MODE_DIGITAL;
        GPIO_InitStruct.outputType = FL_GPIO_OUTPUT_PUSHPULL;
        GPIO_InitStruct.pull       = FL_DISABLE;
        GPIO_InitStruct.remapPin   = FL_ENABLE;
        FL_GPIO_Init(GPIOC, &GPIO_InitStruct);
    }

    FL_LPUART_StructInit(&LPUART_InitStruct);
    LPUART_InitStruct.clockSrc          = FL_CMU_LPUART_CLK_SOURCE_LSCLK;   //ʱԴLSCLK
//  LPUART_InitStruct.clockSrc          = FL_CMU_LPUART_CLK_SOURCE_RCHF;    //ʱԴRCHF
//  LPUART_InitStruct.clockSrc          = FL_CMU_LPUART_CLK_SOURCE_RCLF;    //ʱԴRCLF
    LPUART_InitStruct.baudRate          = FL_LPUART_BAUDRATE_9600;
    LPUART_InitStruct.dataWidth         = FL_LPUART_DATA_WIDTH_8B;
    LPUART_InitStruct.stopBits          = FL_LPUART_STOP_BIT_WIDTH_1B;
    LPUART_InitStruct.parity            = FL_LPUART_PARITY_NONE;
    LPUART_InitStruct.transferDirection = FL_LPUART_DIRECTION_TX_RX;
    FL_LPUART_Init(LPUARTx, &LPUART_InitStruct);

    NVIC_DisableIRQ(LPUARTx_IRQn);
    NVIC_SetPriority(LPUARTx_IRQn, 2);
    NVIC_EnableIRQ(LPUARTx_IRQn);

    FL_LPUART_EnableIT_RXBuffFull(LPUARTx);

    printf("\r\n");

    shell_init();

    printf("\r\n");
}


/*******************************************************************************
 * @brief       
 * @param       
 * @retval      
 * @attention   
*******************************************************************************/
void LPUARTx_IRQHandler(void)
{
    if((FL_ENABLE == FL_LPUART_IsEnabledIT_RXBuffFull(LPUART0)) &&
       (FL_SET    == FL_LPUART_IsActiveFlag_RXBuffFull(LPUART0)) )
    {
        shell(FL_LPUART_ReadRXBuff(LPUART0));
    }

    if((FL_ENABLE == FL_LPUART_IsEnabledIT_RXBuffFull(LPUART1)) &&
       (FL_SET    == FL_LPUART_IsActiveFlag_RXBuffFull(LPUART1)) )
    {
        FL_LPUART_WriteTXBuff(LPUART1, FL_LPUART_ReadRXBuff(LPUART1));
    }
}


/*******************************************************************************
 * @brief       
 * @param       
 * @retval      
 * @attention   
*******************************************************************************/
int fputc(int ch, FILE *f)
{
    FL_LPUART_WriteTXBuff(LPUART0, (uint8_t)ch);

    while(FL_LPUART_IsActiveFlag_TXShiftBuffEmpty(LPUART0) == 0);

    FL_LPUART_ClearFlag_TXShiftBuffEmpty(LPUART0);

    return ch;
}


/******************* (C) COPYRIGHT 2021 *************************END OF FILE***/

