/*******************************************************************************
 * @file    MCU.c
 * @author  King
 * @version V1.00
 * @date    27-Nov-2021
 * @brief   ......
*******************************************************************************/


/* Define to prevent recursive inclusion -------------------------------------*/
#define __MCU_C__


/* Includes ------------------------------------------------------------------*/
#include "MCU.h"


/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/


/* Exported variables --------------------------------------------------------*/
/* Exported function prototypes ----------------------------------------------*/


/*******************************************************************************
 * @brief       
 * @param       
 * @retval      
 * @attention   
*******************************************************************************/
void MCU_PrintLOG(void)
{
    printf("\r\n");
    printf("SystemClockFreq : %dHz\r\n", FL_CMU_GetSystemClockFreq());
    printf("APBClockFreq    : %dHz\r\n", FL_CMU_GetAPBClockFreq()   );
    printf("AHBClockFreq    : %dHz\r\n", FL_CMU_GetAHBClockFreq()   );
    printf("\r\n");
    printf("PLLClockFreq    : %dHz\r\n", FL_CMU_GetPLLClockFreq()   );
    printf("\r\n");
    printf("RCHFClockFreq   : %dHz\r\n", FL_CMU_GetRCHFClockFreq()  );
    printf("RCLFClockFreq   : %dHz\r\n", FL_CMU_GetRCLFClockFreq()  );
    printf("\r\n");
}


/*******************************************************************************
 * @brief       
 * @param       
 * @retval      
 * @attention   
*******************************************************************************/
void MCU_Init(void)
{
    MF_Clock_Init();

    MF_SystemClock_Config();

    FL_Init();

    MF_Config_Init();

    LPTIM32_Init();

    LPUARTx_Init(LPUART0);

    MCU_PrintLOG();
}


/******************* (C) COPYRIGHT 2021 *************************END OF FILE***/

