/*******************************************************************************
 * @file    RTC.c
 * @author  King
 * @version V1.00
 * @date    27-Nov-2021
 * @brief   ......
*******************************************************************************/


/* Define to prevent recursive inclusion -------------------------------------*/
#define __RTC_C__


/* Includes ------------------------------------------------------------------*/
#include "RTC.h"


#if RTC_ENABLE


/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/


/* Exported variables --------------------------------------------------------*/
/* Exported function prototypes ----------------------------------------------*/


/*******************************************************************************
 * @brief       
 * @param       
 * @retval      
 * @attention   
*******************************************************************************/
uint8_t RTC_HEXToBCD(uint8_t Data)
{
    return (Data / 10) * 16 + (Data % 10);
}


/*******************************************************************************
 * @brief       
 * @param       
 * @retval      
 * @attention   
*******************************************************************************/
uint8_t RTC_BCDToHEX(uint8_t Data)
{
    return (Data / 16) * 10 + (Data % 16);
}


/*******************************************************************************
 * @brief       
 * @param       
 * @retval      
 * @attention   
*******************************************************************************/
void RTCB_Configure(void)
{
    FL_RTCB_InitTypeDef RTCB_InitStruct = {0x21, 0x12, 0x12, 0x00, 0x19, 0x18, 0x25};

    FL_RTCB_Init(RTCB, &RTCB_InitStruct);

    FL_RTCB_Enable(RTCB);

    NVIC_DisableIRQ(RTCx_IRQn);
}


/*******************************************************************************
 * @brief       
 * @param       
 * @retval      
 * @attention   
*******************************************************************************/
void RTC_Configure(void)
{
    RTCB_Configure();

    TASK_Append(TASK_ID_RTC, RTC_Handler, 1000);
}


/*******************************************************************************
 * @brief       
 * @param       
 * @retval      
 * @attention   
*******************************************************************************/
void RTC_Handler(void)
{
    FL_RTCB_InitTypeDef RTCB_InitStruct;

    FL_RTCB_GetTime(RTCB, &RTCB_InitStruct);

    printf("\r\n20%02d-%02d-%02d",
           RTC_BCDToHEX(RTCB_InitStruct.year ),
           RTC_BCDToHEX(RTCB_InitStruct.month),
           RTC_BCDToHEX(RTCB_InitStruct.day  ));

    switch(RTCB_InitStruct.week)
    {
        case 0 : printf(" SUN "); break;
        case 1 : printf(" MON "); break;
        case 2 : printf(" TUE "); break;
        case 3 : printf(" WED "); break;
        case 4 : printf(" THU "); break;
        case 5 : printf(" FRI "); break;
        case 6 : printf(" SAT "); break;
        default:break;
    }

    printf("%02d:%02d:%02d",
           RTC_BCDToHEX(RTCB_InitStruct.hour  ),
           RTC_BCDToHEX(RTCB_InitStruct.minute),
           RTC_BCDToHEX(RTCB_InitStruct.second));
}


#endif


/******************* (C) COPYRIGHT 2021 *************************END OF FILE***/

