/*******************************************************************************
 * @file    TASK.h
 * @author  King
 * @version V1.00
 * @date    27-Nov-2021
 * @brief   ......
*******************************************************************************/


/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __TASK_H__
#define __TASK_H__


#ifdef __cplusplus
extern "C" {
#endif


#undef  EXTERN


#ifdef  __TASK_C__
#define EXTERN
#else
#define EXTERN extern
#endif


/* Includes ------------------------------------------------------------------*/
#include "config.h"


/* Exported constants --------------------------------------------------------*/
#define TASK_ID_KEY     0
#define TASK_ID_LED     1
#define TASK_ID_ADC     2
#define TASK_ID_CAN     3
#define TASK_ID_DAC     4
#define TASK_ID_OLED1   5
#define TASK_ID_OLED2   6
#define TASK_ID_RTC     7
#define TASK_ID_LCD     8


/* Exported types ------------------------------------------------------------*/
typedef void(*Task_Handler)(void);


/* Exported types ------------------------------------------------------------*/
typedef struct
{
    uint8_t  index;
    uint8_t  ready;
    uint32_t tick;
    Task_Handler handler;
} TASK_InfoTypeDef;


/* Exported types ------------------------------------------------------------*/
typedef struct _Node_Struct
{
    TASK_InfoTypeDef info;
    struct _Node_Struct *next;
} LinkedList_TypeDef;


/* Exported macro ------------------------------------------------------------*/


/* Exported functions --------------------------------------------------------*/
EXTERN void TASK_Append(uint8_t index, Task_Handler handler, uint32_t tick);
EXTERN void TASK_TimeSlice(uint32_t tick);
EXTERN void TASK_Scheduling(void);


#ifdef __cplusplus
}
#endif


#endif


/******************* (C) COPYRIGHT 2021 *************************END OF FILE***/

